/*
 * Copyright 2005, Mamezou Co.,LTD.
 */
package jp.co.thinkit.employee.business;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.dao.DataAccessException;

/**
 * ]ƈǗ̃rWlXNX
 * @author Mamezou
 * @version 1.0
 */
public class EmployeeManagerImpl implements EmployeeManager {
    // pDAOBSpringɂăCWFNVB
    private EmployeeDao employeeDao;
    
    // Ȍ͉fIȊ֐Sł
    public static final Log log = LogFactory.getLog(EmployeeManagerImpl.class);  

    // DAOp̃Zb^[CWFNV
    public void setEmployeeDao(EmployeeDao employeeDao) {
        this.employeeDao = employeeDao;
    }

    /**
     * SĂ̏]ƈB
     * (OO͉fIȊ֐Sł)
     * @return SĂ̏]ƈ
     */
    public List findAll() {
        log.trace("Start findAll()");
        List emps = null;
        try {
            // SĂ̏]ƈB
            emps = employeeDao.findAll();
        } catch(DataAccessException e) {
            log.error(e);
            throw e;
        }
        log.trace("End findAll()");
        return emps;
    }

    /**
     * ]ƈǉB
     * (OO͉fIȊ֐Sł)
     * @param emp ]ƈNX
     * @return ǉ]ƈiK1j
     */
    public int addEmployee(Employee emp) {
        log.trace("Start addEmployee()");
        int ret = 0;
        try {
            // ]ƈǉB
            ret = employeeDao.addEmployee(emp);
        }catch(DataAccessException e) {
            log.error(e);
            throw e;
        }
        
        log.trace("End addEmployee()");
        return ret;
    }

    /**
     * ]ƈ폜B
     * (OO͉fIȊ֐Sł)
     * @param emp ]ƈNX
     * @return 폜]ƈiK1j
     */
    public int removeEmployee(Employee emp) {
        log.trace("Start removeEmployee()");
        int ret = 0;
        try {
            // ]ƈ폜B
            ret = employeeDao.removeEmployee(emp);
        }catch(DataAccessException e) {
            log.error(e);
            throw e;
        }

        log.trace("End removeEmployee()");
        return ret;
    }
}